diff --git a/gcc/analyzer/sm-fd.cc b/gcc/analyzer/sm-fd.cc
index b8ae0a1747e..f694223bee9 100644
--- a/gcc/analyzer/sm-fd.cc
+++ b/gcc/analyzer/sm-fd.cc
@@ -2715,8 +2675,7 @@ class kf_isatty : public known_function
 	    return true;
 
 	  const svalue *fd_sval = cd.get_arg_svalue (0);
-	  state_machine::state_t old_state
-	    = sm_ctxt->get_state (&cd.get_call_stmt (), fd_sval);
+	  state_machine::state_t old_state = sm_ctxt->get_state (fd_sval);
 
 	  if (fd_sm->is_closed_fd_p (old_state)
 	      || old_state == fd_sm->m_invalid)
diff --git a/gcc/analyzer/sm-file.cc b/gcc/analyzer/sm-file.cc
index c852c02804b..eab8025d579 100644
--- a/gcc/analyzer/sm-file.cc
+++ b/gcc/analyzer/sm-file.cc
@@ -62,12 +62,9 @@ public:
   }
 
   bool on_stmt (sm_context &sm_ctxt,
-		const supernode *node,
 		const gimple *stmt) const final override;
 
   void on_condition (sm_context &sm_ctxt,
-		     const supernode *node,
-		     const gimple *stmt,
 		     const svalue *lhs,
 		     enum tree_code op,
 		     const svalue *rhs) const final override;
@@ -408,7 +405,6 @@ is_file_using_fn_p (tree fndecl)
 
 bool
 fileptr_state_machine::on_stmt (sm_context &sm_ctxt,
-				const supernode *node,
 				const gimple *stmt) const
 {
   if (const gcall *call = dyn_cast <const gcall *> (stmt))
@@ -418,7 +414,7 @@ fileptr_state_machine::on_stmt (sm_context &sm_ctxt,
 	  {
 	    tree lhs = gimple_call_lhs (call);
 	    if (lhs)
-	      sm_ctxt.on_transition (node, stmt, lhs, m_start, m_unchecked);
+	      sm_ctxt.on_transition (lhs, m_start, m_unchecked);
 	    else
 	      {
 		/* TODO: report leak.  */
@@ -430,21 +426,21 @@ fileptr_state_machine::on_stmt (sm_context &sm_ctxt,
 	  {
 	    tree arg = gimple_call_arg (call, 0);
 
-	    sm_ctxt.on_transition (node, stmt, arg, m_start, m_closed);
+	    sm_ctxt.on_transition (arg, m_start, m_closed);
 
 	    // TODO: is it safe to call fclose (NULL) ?
-	    sm_ctxt.on_transition (node, stmt, arg, m_unchecked, m_closed);
-	    sm_ctxt.on_transition (node, stmt, arg, m_null, m_closed);
+	    sm_ctxt.on_transition (arg, m_unchecked, m_closed);
+	    sm_ctxt.on_transition (arg, m_null, m_closed);
 
-	    sm_ctxt.on_transition (node, stmt , arg, m_nonnull, m_closed);
+	    sm_ctxt.on_transition (arg, m_nonnull, m_closed);
 
-	    if (sm_ctxt.get_state (stmt, arg) == m_closed)
+	    if (sm_ctxt.get_state (arg) == m_closed)
 	      {
 		tree diag_arg = sm_ctxt.get_diagnostic_tree (arg);
-		sm_ctxt.warn (node, stmt, arg,
+		sm_ctxt.warn (arg,
 			      std::make_unique<double_fclose> (*this,
 							       diag_arg));
-		sm_ctxt.set_next_state (stmt, arg, m_stop);
+		sm_ctxt.set_next_state (arg, m_stop);
 	      }
 	    return true;
 	  }
@@ -466,8 +462,6 @@ fileptr_state_machine::on_stmt (sm_context &sm_ctxt,
 
 void
 fileptr_state_machine::on_condition (sm_context &sm_ctxt,
-				     const supernode *node,
-				     const gimple *stmt,
 				     const svalue *lhs,
 				     enum tree_code op,
 				     const svalue *rhs) const
@@ -485,14 +479,12 @@ fileptr_state_machine::on_condition (sm_context &sm_ctxt,
   if (op == NE_EXPR)
     {
       log ("got 'ARG != 0' match");
-      sm_ctxt.on_transition (node, stmt,
-			     lhs, m_unchecked, m_nonnull);
+      sm_ctxt.on_transition (lhs, m_unchecked, m_nonnull);
     }
   else if (op == EQ_EXPR)
     {
       log ("got 'ARG == 0' match");
-      sm_ctxt.on_transition (node, stmt,
-			     lhs, m_unchecked, m_null);
+      sm_ctxt.on_transition (lhs, m_unchecked, m_null);
     }
 }
 
@@ -687,12 +679,17 @@ register_known_file_functions (known_function_manager &kfm)
   kfm.add (BUILT_IN_VPRINTF, std::make_unique<kf_stdio_output_fn> ());
 
   kfm.add ("ferror", std::make_unique<kf_ferror> ());
+  kfm.add ("ferror_unlocked", std::make_unique<kf_ferror> ());
   kfm.add ("fgets", std::make_unique<kf_fgets> ());
   kfm.add ("fgets_unlocked", std::make_unique<kf_fgets> ()); // non-standard
   kfm.add ("fileno", std::make_unique<kf_fileno> ());
+  kfm.add ("fileno_unlocked", std::make_unique<kf_fileno> ());
   kfm.add ("fread", std::make_unique<kf_fread> ());
+  kfm.add ("fread_unlocked", std::make_unique<kf_fread> ());
   kfm.add ("getc", std::make_unique<kf_getc> ());
+  kfm.add ("getc_unlocked", std::make_unique<kf_getc> ());
   kfm.add ("getchar", std::make_unique<kf_getchar> ());
+  kfm.add ("getchar_unlocked", std::make_unique<kf_getchar> ());
 
   /* Some C++ implementations use the std:: copies of these functions
      from <cstdio> for <stdio.h>, so we must match against these too.  */
diff --git a/gcc/analyzer/sm-malloc.cc b/gcc/analyzer/sm-malloc.cc
index 88bfc74888c..614462ba5b3 100644
--- a/gcc/analyzer/sm-malloc.cc
+++ b/gcc/analyzer/sm-malloc.cc
@@ -386,17 +386,17 @@ public:
   }
 
   bool on_stmt (sm_context &sm_ctxt,
-		const supernode *node,
 		const gimple *stmt) const final override;
 
   void on_phi (sm_context &sm_ctxt,
-	       const supernode *node,
 	       const gphi *phi,
 	       tree rhs) const final override;
 
+  void
+  check_call_preconditions (sm_context &sm_ctxt,
+			    const call_details &cd) const final override;
+
   void on_condition (sm_context &sm_ctxt,
-		     const supernode *node,
-		     const gimple *stmt,
 		     const svalue *lhs,
 		     enum tree_code op,
 		     const svalue *rhs) const final override;
@@ -421,8 +421,7 @@ public:
   static bool unaffected_by_call_p (tree fndecl);
 
   void maybe_assume_non_null (sm_context &sm_ctxt,
-			      tree ptr,
-			      const gimple *stmt) const;
+			      tree ptr) const;
 
   void on_realloc_with_move (region_model *model,
 			     sm_state_map *smap,
@@ -476,8 +475,6 @@ private:
 
   void
   maybe_complain_about_deref_before_check (sm_context &sm_ctxt,
-					   const supernode *node,
-					   const gimple *stmt,
 					   const assumed_non_null_state *,
 					   tree ptr) const;
 
@@ -486,24 +483,18 @@ private:
 			  const deallocator_set *deallocators,
 			  bool returns_nonnull = false) const;
   void handle_free_of_non_heap (sm_context &sm_ctxt,
-				const supernode *node,
 				const gcall &call,
 				tree arg,
 				const deallocator *d) const;
   void on_deallocator_call (sm_context &sm_ctxt,
-			    const supernode *node,
 			    const gcall &call,
 			    const deallocator *d,
 			    unsigned argno) const;
   void on_realloc_call (sm_context &sm_ctxt,
-			const supernode *node,
 			const gcall &call) const;
   void on_zero_assignment (sm_context &sm_ctxt,
-			   const gimple *stmt,
 			   tree lhs) const;
   void handle_nonnull (sm_context &sm_ctx,
-		       const supernode *node,
-		       const gimple *stmt,
 		       tree fndecl,
 		       tree arg,
 		       unsigned i) const;
@@ -1782,13 +1773,9 @@ private:
     const supernode *snode = point.get_supernode ();
     if (!snode)
       return false;
-    for (auto &in_edge : snode->m_preds)
-      {
-	if (const cfg_superedge *cfg_in_edge
-	      = in_edge->dyn_cast_cfg_superedge ())
-	  if (cfg_in_edge->back_edge_p ())
-	    return true;
-      }
+    for (auto in_edge : snode->m_bb->preds)
+      if (in_edge->flags & EDGE_DFS_BACK)
+	return true;
     return false;
   }
 
@@ -2043,8 +2030,7 @@ known_allocator_p (const_tree fndecl, const gcall &call)
 
 void
 malloc_state_machine::maybe_assume_non_null (sm_context &sm_ctxt,
-					     tree ptr,
-					     const gimple *stmt) const
+					     tree ptr) const
 {
   const region_model *old_model = sm_ctxt.get_old_region_model ();
   if (!old_model)
@@ -2061,7 +2047,7 @@ malloc_state_machine::maybe_assume_non_null (sm_context &sm_ctxt,
       state_t next_state
 	= mut_this->get_or_create_assumed_non_null_state_for_frame
 	(old_model->get_current_frame ());
-      sm_ctxt.set_next_state (stmt, ptr, next_state);
+      sm_ctxt.set_next_state (ptr, next_state);
     }
 }
 
@@ -2071,13 +2057,11 @@ malloc_state_machine::maybe_assume_non_null (sm_context &sm_ctxt,
 
 void
 malloc_state_machine::handle_nonnull (sm_context &sm_ctxt,
-				      const supernode *node,
-				      const gimple *stmt,
 				      tree fndecl,
 				      tree arg,
 				      unsigned i) const
 {
-  state_t state = sm_ctxt.get_state (stmt, arg);
+  state_t state = sm_ctxt.get_state (arg);
   /* Can't use a switch as the states are non-const.  */
   /* Do use the fndecl that caused the warning so that the
      misused attributes are printed and the user not confused.  */
@@ -2085,29 +2069,28 @@ malloc_state_machine::handle_nonnull (sm_context &sm_ctxt,
     {
       tree diag_arg = sm_ctxt.get_diagnostic_tree (arg);
       sm_ctxt.warn
-	(node, stmt, arg,
+	(arg,
 	 std::make_unique<possible_null_arg> (*this, diag_arg, fndecl,
 					      i));
       const allocation_state *astate
 	= as_a_allocation_state (state);
-      sm_ctxt.set_next_state (stmt, arg, astate->get_nonnull ());
+      sm_ctxt.set_next_state (arg, astate->get_nonnull ());
     }
   else if (state == m_null)
     {
       tree diag_arg = sm_ctxt.get_diagnostic_tree (arg);
-      sm_ctxt.warn (node, stmt, arg,
+      sm_ctxt.warn (arg,
 		    std::make_unique<null_arg> (*this, diag_arg, fndecl, i));
-      sm_ctxt.set_next_state (stmt, arg, m_stop);
+      sm_ctxt.set_next_state (arg, m_stop);
     }
   else if (state == m_start)
-    maybe_assume_non_null (sm_ctxt, arg, stmt);
+    maybe_assume_non_null (sm_ctxt, arg);
 }
 
 /* Implementation of state_machine::on_stmt vfunc for malloc_state_machine.  */
 
 bool
 malloc_state_machine::on_stmt (sm_context &sm_ctxt,
-			       const supernode *node,
 			       const gimple *stmt) const
 {
   if (const gcall *call_stmt = dyn_cast <const gcall *> (stmt))
@@ -2136,13 +2119,13 @@ malloc_state_machine::on_stmt (sm_context &sm_ctxt,
 	if (is_named_call_p (callee_fndecl, "operator delete", call, 1)
 	    || is_named_call_p (callee_fndecl, "operator delete", call, 2))
 	  {
-	    on_deallocator_call (sm_ctxt, node, call,
+	    on_deallocator_call (sm_ctxt, call,
 				 &m_scalar_delete.m_deallocator, 0);
 	    return true;
 	  }
 	else if (is_named_call_p (callee_fndecl, "operator delete []", call, 1))
 	  {
-	    on_deallocator_call (sm_ctxt, node, call,
+	    on_deallocator_call (sm_ctxt, call,
 				 &m_vector_delete.m_deallocator, 0);
 	    return true;
 	  }
@@ -2152,7 +2135,7 @@ malloc_state_machine::on_stmt (sm_context &sm_ctxt,
 	  {
 	    tree lhs = gimple_call_lhs (&call);
 	    if (lhs)
-	      sm_ctxt.on_transition (node, stmt, lhs, m_start, m_non_heap);
+	      sm_ctxt.on_transition (lhs, m_start, m_non_heap);
 	    return true;
 	  }
 
@@ -2160,7 +2143,7 @@ malloc_state_machine::on_stmt (sm_context &sm_ctxt,
 	    || is_std_named_call_p (callee_fndecl, "free", call, 1)
 	    || is_named_call_p (callee_fndecl, "__builtin_free", call, 1))
 	  {
-	    on_deallocator_call (sm_ctxt, node, call,
+	    on_deallocator_call (sm_ctxt, call,
 				 &m_free.m_deallocator, 0);
 	    return true;
 	  }
@@ -2169,7 +2152,7 @@ malloc_state_machine::on_stmt (sm_context &sm_ctxt,
 	    || is_std_named_call_p (callee_fndecl, "realloc", call, 2)
 	    || is_named_call_p (callee_fndecl, "__builtin_realloc", call, 2))
 	  {
-	    on_realloc_call (sm_ctxt, node, call);
+	    on_realloc_call (sm_ctxt, call);
 	    return true;
 	  }
 
@@ -2204,62 +2187,6 @@ malloc_state_machine::on_stmt (sm_context &sm_ctxt,
 	      on_allocator_call (sm_ctxt, call, deallocators, returns_nonnull);
 	    }
 
-	  {
-	    /* Handle "__attribute__((nonnull))".   */
-	    tree fntype = TREE_TYPE (fndecl);
-	    bitmap nonnull_args = get_nonnull_args (fntype);
-	    if (nonnull_args)
-	      {
-		for (unsigned i = 0; i < gimple_call_num_args (stmt); i++)
-		  {
-		    tree arg = gimple_call_arg (stmt, i);
-		    if (TREE_CODE (TREE_TYPE (arg)) != POINTER_TYPE)
-		      continue;
-		    /* If we have a nonnull-args, and either all pointers, or
-		       just the specified pointers.  */
-		    if (bitmap_empty_p (nonnull_args)
-			|| bitmap_bit_p (nonnull_args, i))
-		      handle_nonnull (sm_ctxt, node, stmt, fndecl, arg, i);
-		  }
-		BITMAP_FREE (nonnull_args);
-	      }
-	    /* Handle __attribute__((nonnull_if_nonzero (x, y))).  */
-	    if (fntype)
-	      for (tree attrs = TYPE_ATTRIBUTES (fntype);
-		   (attrs = lookup_attribute ("nonnull_if_nonzero", attrs));
-		   attrs = TREE_CHAIN (attrs))
-		{
-		  tree args = TREE_VALUE (attrs);
-		  unsigned int idx = TREE_INT_CST_LOW (TREE_VALUE (args)) - 1;
-		  unsigned int idx2
-		    = TREE_INT_CST_LOW (TREE_VALUE (TREE_CHAIN (args))) - 1;
-		  unsigned int idx3 = idx2;
-		  if (tree chain2 = TREE_CHAIN (TREE_CHAIN (args)))
-		    idx3 = TREE_INT_CST_LOW (TREE_VALUE (chain2)) - 1;
-		  if (idx < gimple_call_num_args (stmt)
-		      && idx2 < gimple_call_num_args (stmt)
-		      && idx3 < gimple_call_num_args (stmt))
-		    {
-		      tree arg = gimple_call_arg (stmt, idx);
-		      tree arg2 = gimple_call_arg (stmt, idx2);
-		      tree arg3 = gimple_call_arg (stmt, idx3);
-		      if (TREE_CODE (TREE_TYPE (arg)) != POINTER_TYPE
-			  || !INTEGRAL_TYPE_P (TREE_TYPE (arg2))
-			  || !INTEGRAL_TYPE_P (TREE_TYPE (arg3))
-			  || integer_zerop (arg2)
-			  || integer_zerop (arg3))
-			continue;
-		      if (integer_nonzerop (arg2) && integer_nonzerop (arg3))
-			;
-		      else
-			/* FIXME: Use ranger here to query arg2 and arg3
-			   ranges?  */
-			continue;
-		      handle_nonnull (sm_ctxt, node, stmt, fndecl, arg, idx);
-		    }
-		}
-	  }
-
 	  /* Check for this after nonnull, so that if we have both
 	     then we transition to "freed", rather than "checked".  */
 	  unsigned dealloc_argno = fndecl_dealloc_argno (fndecl);
@@ -2267,7 +2194,7 @@ malloc_state_machine::on_stmt (sm_context &sm_ctxt,
 	    {
 	      const deallocator *d
 		= mutable_this->get_or_create_deallocator (fndecl);
-	      on_deallocator_call (sm_ctxt, node, call, d, dealloc_argno);
+	      on_deallocator_call (sm_ctxt, call, d, dealloc_argno);
 	    }
 	}
       }
@@ -2291,11 +2218,10 @@ malloc_state_machine::on_stmt (sm_context &sm_ctxt,
 	      && any_pointer_p (rhs)
 	      && zerop (rhs))
 	    {
-	      state_t state = sm_ctxt.get_state (stmt, lhs);
+	      state_t state = sm_ctxt.get_state (lhs);
 	      if (assumed_non_null_p (state))
 		maybe_complain_about_deref_before_check
-		  (sm_ctxt, node,
-		   stmt,
+		  (sm_ctxt,
 		   (const assumed_non_null_state *)state,
 		   lhs);
 	    }
@@ -2304,7 +2230,7 @@ malloc_state_machine::on_stmt (sm_context &sm_ctxt,
 
   if (tree lhs = sm_ctxt.is_zero_assignment (stmt))
     if (any_pointer_p (lhs))
-      on_zero_assignment (sm_ctxt, stmt,lhs);
+      on_zero_assignment (sm_ctxt, lhs);
 
   /* Handle dereferences.  */
   for (unsigned i = 0; i < gimple_num_ops (stmt); i++)
@@ -2319,33 +2245,33 @@ malloc_state_machine::on_stmt (sm_context &sm_ctxt,
 	{
 	  tree arg = TREE_OPERAND (op, 0);
 
-	  state_t state = sm_ctxt.get_state (stmt, arg);
+	  state_t state = sm_ctxt.get_state (arg);
 	  if (state == m_start)
-	    maybe_assume_non_null (sm_ctxt, arg, stmt);
+	    maybe_assume_non_null (sm_ctxt, arg);
 	  else if (unchecked_p (state))
 	    {
 	      tree diag_arg = sm_ctxt.get_diagnostic_tree (arg);
-	      sm_ctxt.warn (node, stmt, arg,
+	      sm_ctxt.warn (arg,
 			    std::make_unique<possible_null_deref> (*this,
 								   diag_arg));
 	      const allocation_state *astate = as_a_allocation_state (state);
-	      sm_ctxt.set_next_state (stmt, arg, astate->get_nonnull ());
+	      sm_ctxt.set_next_state (arg, astate->get_nonnull ());
 	    }
 	  else if (state == m_null)
 	    {
 	      tree diag_arg = sm_ctxt.get_diagnostic_tree (arg);
-	      sm_ctxt.warn (node, stmt, arg,
+	      sm_ctxt.warn (arg,
 			    std::make_unique<null_deref> (*this, diag_arg));
-	      sm_ctxt.set_next_state (stmt, arg, m_stop);
+	      sm_ctxt.set_next_state (arg, m_stop);
 	    }
 	  else if (freed_p (state))
 	    {
 	      tree diag_arg = sm_ctxt.get_diagnostic_tree (arg);
 	      const allocation_state *astate = as_a_allocation_state (state);
-	      sm_ctxt.warn (node, stmt, arg,
+	      sm_ctxt.warn (arg,
 			    std::make_unique<use_after_free>
 			      (*this, diag_arg, astate->m_deallocator));
-	      sm_ctxt.set_next_state (stmt, arg, m_stop);
+	      sm_ctxt.set_next_state (arg, m_stop);
 	    }
 	}
     }
@@ -2358,8 +2284,6 @@ malloc_state_machine::on_stmt (sm_context &sm_ctxt,
 void
 malloc_state_machine::
 maybe_complain_about_deref_before_check (sm_context &sm_ctxt,
-					 const supernode *node,
-					 const gimple *stmt,
 					 const assumed_non_null_state *state,
 					 tree ptr) const
 {
@@ -2394,19 +2318,22 @@ maybe_complain_about_deref_before_check (sm_context &sm_ctxt,
 
   /* Don't complain if STMT was inlined from another function, to avoid
      similar false positives involving shared helper functions.  */
+  // FIXME
+#if 0
   if (stmt->location)
     {
       inlining_info info (stmt->location);
       if (info.get_extra_frames () > 0)
 	return;
     }
+#endif
 
   tree diag_ptr = sm_ctxt.get_diagnostic_tree (ptr);
   if (diag_ptr)
     sm_ctxt.warn
-      (node, stmt, ptr,
+      (ptr,
        std::make_unique<deref_before_check> (*this, diag_ptr));
-  sm_ctxt.set_next_state (stmt, ptr, m_stop);
+  sm_ctxt.set_next_state (ptr, m_stop);
 }
 
 /* Handle a call to an allocator.
@@ -2422,8 +2349,8 @@ malloc_state_machine::on_allocator_call (sm_context &sm_ctxt,
   tree lhs = gimple_call_lhs (&call);
   if (lhs)
     {
-      if (sm_ctxt.get_state (&call, lhs) == m_start)
-	sm_ctxt.set_next_state (&call, lhs,
+      if (sm_ctxt.get_state (lhs) == m_start)
+	sm_ctxt.set_next_state (lhs,
 				(returns_nonnull
 				 ? deallocators->m_nonnull
 				 : deallocators->m_unchecked));
@@ -2439,8 +2366,7 @@ malloc_state_machine::on_allocator_call (sm_context &sm_ctxt,
 
 void
 malloc_state_machine::handle_free_of_non_heap (sm_context &sm_ctxt,
-					       const supernode *node,
-					       const gcall &call,
+					       const gcall &,
 					       tree arg,
 					       const deallocator *d) const
 {
@@ -2452,15 +2378,14 @@ malloc_state_machine::handle_free_of_non_heap (sm_context &sm_ctxt,
       const svalue *ptr_sval = old_model->get_rvalue (arg, nullptr);
       freed_reg = old_model->deref_rvalue (ptr_sval, arg, nullptr);
     }
-  sm_ctxt.warn (node, &call, arg,
+  sm_ctxt.warn (arg,
 		std::make_unique<free_of_non_heap>
 		  (*this, diag_arg, freed_reg, d->m_name));
-  sm_ctxt.set_next_state (&call, arg, m_stop);
+  sm_ctxt.set_next_state (arg, m_stop);
 }
 
 void
 malloc_state_machine::on_deallocator_call (sm_context &sm_ctxt,
-					   const supernode *node,
 					   const gcall &call,
 					   const deallocator *d,
 					   unsigned argno) const
@@ -2469,11 +2394,11 @@ malloc_state_machine::on_deallocator_call (sm_context &sm_ctxt,
     return;
   tree arg = gimple_call_arg (&call, argno);
 
-  state_t state = sm_ctxt.get_state (&call, arg);
+  state_t state = sm_ctxt.get_state (arg);
 
   /* start/assumed_non_null/unchecked/nonnull -> freed.  */
   if (state == m_start || assumed_non_null_p (state))
-    sm_ctxt.set_next_state (&call, arg, d->m_freed);
+    sm_ctxt.set_next_state (arg, d->m_freed);
   else if (unchecked_p (state) || nonnull_p (state))
     {
       const allocation_state *astate = as_a_allocation_state (state);
@@ -2482,13 +2407,13 @@ malloc_state_machine::on_deallocator_call (sm_context &sm_ctxt,
 	{
 	  /* Wrong allocator.  */
 	  tree diag_arg = sm_ctxt.get_diagnostic_tree (arg);
-	  sm_ctxt.warn (node, &call, arg,
+	  sm_ctxt.warn (arg,
 			std::make_unique<mismatching_deallocation>
 			  (*this, diag_arg,
 			   astate->m_deallocators,
 			   d));
 	}
-      sm_ctxt.set_next_state (&call, arg, d->m_freed);
+      sm_ctxt.set_next_state (arg, d->m_freed);
     }
 
   /* Keep state "null" as-is, rather than transitioning to "freed";
@@ -2497,14 +2422,14 @@ malloc_state_machine::on_deallocator_call (sm_context &sm_ctxt,
     {
       /* freed -> stop, with warning.  */
       tree diag_arg = sm_ctxt.get_diagnostic_tree (arg);
-      sm_ctxt.warn (node, &call, arg,
+      sm_ctxt.warn (arg,
 		    std::make_unique<double_free> (*this, diag_arg, d->m_name));
-      sm_ctxt.set_next_state (&call, arg, m_stop);
+      sm_ctxt.set_next_state (arg, m_stop);
     }
   else if (state == m_non_heap)
     {
       /* non-heap -> stop, with warning.  */
-      handle_free_of_non_heap (sm_ctxt, node, call, arg, d);
+      handle_free_of_non_heap (sm_ctxt, call, arg, d);
     }
 }
 
@@ -2518,7 +2443,6 @@ malloc_state_machine::on_deallocator_call (sm_context &sm_ctxt,
 
 void
 malloc_state_machine::on_realloc_call (sm_context &sm_ctxt,
-				       const supernode *node,
 				       const gcall &call) const
 {
   const unsigned argno = 0;
@@ -2526,7 +2450,7 @@ malloc_state_machine::on_realloc_call (sm_context &sm_ctxt,
 
   tree arg = gimple_call_arg (&call, argno);
 
-  state_t state = sm_ctxt.get_state (&call, arg);
+  state_t state = sm_ctxt.get_state (arg);
 
   if (unchecked_p (state) || nonnull_p (state))
     {
@@ -2536,11 +2460,11 @@ malloc_state_machine::on_realloc_call (sm_context &sm_ctxt,
 	{
 	  /* Wrong allocator.  */
 	  tree diag_arg = sm_ctxt.get_diagnostic_tree (arg);
-	  sm_ctxt.warn (node, &call, arg,
+	  sm_ctxt.warn (arg,
 			std::make_unique<mismatching_deallocation>
 			  (*this, diag_arg,
 			   astate->m_deallocators, d));
-	  sm_ctxt.set_next_state (&call, arg, m_stop);
+	  sm_ctxt.set_next_state (arg, m_stop);
 	  if (path_context *path_ctxt = sm_ctxt.get_path_context ())
 	    path_ctxt->terminate_path ();
 	}
@@ -2549,16 +2473,16 @@ malloc_state_machine::on_realloc_call (sm_context &sm_ctxt,
     {
       /* freed -> stop, with warning.  */
       tree diag_arg = sm_ctxt.get_diagnostic_tree (arg);
-      sm_ctxt.warn (node, &call, arg,
+      sm_ctxt.warn (arg,
 		    std::make_unique<double_free> (*this, diag_arg, "free"));
-      sm_ctxt.set_next_state (&call, arg, m_stop);
+      sm_ctxt.set_next_state (arg, m_stop);
       if (path_context *path_ctxt = sm_ctxt.get_path_context ())
 	path_ctxt->terminate_path ();
     }
   else if (state == m_non_heap)
     {
       /* non-heap -> stop, with warning.  */
-      handle_free_of_non_heap (sm_ctxt, node, call, arg, d);
+      handle_free_of_non_heap (sm_ctxt, call, arg, d);
       if (path_context *path_ctxt = sm_ctxt.get_path_context ())
 	path_ctxt->terminate_path ();
     }
@@ -2568,15 +2492,79 @@ malloc_state_machine::on_realloc_call (sm_context &sm_ctxt,
 
 void
 malloc_state_machine::on_phi (sm_context &sm_ctxt,
-			      const supernode *node ATTRIBUTE_UNUSED,
 			      const gphi *phi,
 			      tree rhs) const
 {
   if (zerop (rhs))
     {
       tree lhs = gimple_phi_result (phi);
-      on_zero_assignment (sm_ctxt, phi, lhs);
+      on_zero_assignment (sm_ctxt, lhs);
+    }
+}
+
+void
+malloc_state_machine::check_call_preconditions (sm_context &sm_ctxt,
+						const call_details &cd) const
+{
+  tree fndecl = cd.get_fndecl_for_call ();
+  if (!fndecl)
+    return;
+
+  const tree fntype = TREE_TYPE (fndecl);
+  const unsigned num_args = cd.num_args ();
+
+  /* Handle "__attribute__((nonnull))".   */
+  if (bitmap nonnull_args = get_nonnull_args (fntype))
+    {
+      for (unsigned i = 0; i < num_args; i++)
+	{
+	  tree arg = cd.get_arg_tree (i);
+	  if (TREE_CODE (TREE_TYPE (arg)) != POINTER_TYPE)
+	    continue;
+	  /* If we have a nonnull-args, and either all pointers, or
+	     just the specified pointers.  */
+	  if (bitmap_empty_p (nonnull_args)
+	      || bitmap_bit_p (nonnull_args, i))
+	    handle_nonnull (sm_ctxt, fndecl, arg, i);
+	}
+      BITMAP_FREE (nonnull_args);
     }
+
+  /* Handle __attribute__((nonnull_if_nonzero (x, y))).  */
+  if (fntype)
+    for (tree attrs = TYPE_ATTRIBUTES (fntype);
+	 (attrs = lookup_attribute ("nonnull_if_nonzero", attrs));
+	 attrs = TREE_CHAIN (attrs))
+      {
+	tree args = TREE_VALUE (attrs);
+	unsigned int idx = TREE_INT_CST_LOW (TREE_VALUE (args)) - 1;
+	unsigned int idx2
+	  = TREE_INT_CST_LOW (TREE_VALUE (TREE_CHAIN (args))) - 1;
+	unsigned int idx3 = idx2;
+	if (tree chain2 = TREE_CHAIN (TREE_CHAIN (args)))
+	  idx3 = TREE_INT_CST_LOW (TREE_VALUE (chain2)) - 1;
+	if (idx < num_args
+	    && idx2 < num_args
+	    && idx3 < num_args)
+	  {
+	    tree arg = cd.get_arg_tree (idx);
+	    tree arg2 = cd.get_arg_tree (idx2);
+	    tree arg3 = cd.get_arg_tree (idx3);
+	    if (TREE_CODE (TREE_TYPE (arg)) != POINTER_TYPE
+		|| !INTEGRAL_TYPE_P (TREE_TYPE (arg2))
+		|| !INTEGRAL_TYPE_P (TREE_TYPE (arg3))
+		|| integer_zerop (arg2)
+		|| integer_zerop (arg3))
+	      continue;
+	    if (integer_nonzerop (arg2) && integer_nonzerop (arg3))
+	      ;
+	    else
+	      /* FIXME: Use ranger here to query arg2 and arg3
+		 ranges?  */
+	      continue;
+	    handle_nonnull (sm_ctxt, fndecl, arg, idx);
+	  }
+      }
 }
 
 /* Implementation of state_machine::on_condition vfunc for malloc_state_machine.
@@ -2584,8 +2572,6 @@ malloc_state_machine::on_phi (sm_context &sm_ctxt,
 
 void
 malloc_state_machine::on_condition (sm_context &sm_ctxt,
-				    const supernode *node ATTRIBUTE_UNUSED,
-				    const gimple *stmt,
 				    const svalue *lhs,
 				    enum tree_code op,
 				    const svalue *rhs) const
@@ -2601,19 +2587,19 @@ malloc_state_machine::on_condition (sm_context &sm_ctxt,
   if (op == NE_EXPR)
     {
       log ("got 'ARG != 0' match");
-      state_t s = sm_ctxt.get_state (stmt, lhs);
+      state_t s = sm_ctxt.get_state (lhs);
       if (unchecked_p (s))
 	{
 	  const allocation_state *astate = as_a_allocation_state (s);
-	  sm_ctxt.set_next_state (stmt, lhs, astate->get_nonnull ());
+	  sm_ctxt.set_next_state (lhs, astate->get_nonnull ());
 	}
     }
   else if (op == EQ_EXPR)
     {
       log ("got 'ARG == 0' match");
-      state_t s = sm_ctxt.get_state (stmt, lhs);
+      state_t s = sm_ctxt.get_state (lhs);
       if (unchecked_p (s))
-	sm_ctxt.set_next_state (stmt, lhs, m_null);
+	sm_ctxt.set_next_state (lhs, m_null);
     }
 }
 
@@ -2724,16 +2710,15 @@ malloc_state_machine::unaffected_by_call_p (tree fndecl)
 
 void
 malloc_state_machine::on_zero_assignment (sm_context &sm_ctxt,
-					  const gimple *stmt,
 					  tree lhs) const
 {
-  state_t s = sm_ctxt.get_state (stmt, lhs);
+  state_t s = sm_ctxt.get_state (lhs);
   enum resource_state rs = get_rs (s);
   if (rs == RS_START
       || rs == RS_UNCHECKED
       || rs == RS_NONNULL
       || rs == RS_FREED)
-    sm_ctxt.set_next_state (stmt, lhs, m_null);
+    sm_ctxt.set_next_state (lhs, m_null);
 }
 
 /* Special-case hook for handling realloc, for the "success with move to
diff --git a/gcc/analyzer/sm-pattern-test.cc b/gcc/analyzer/sm-pattern-test.cc
index 12449a1d48d..b87a40c0332 100644
--- a/gcc/analyzer/sm-pattern-test.cc
+++ b/gcc/analyzer/sm-pattern-test.cc
@@ -50,12 +50,9 @@ public:
   bool inherited_state_p () const final override { return false; }
 
   bool on_stmt (sm_context &sm_ctxt,
-		const supernode *node,
 		const gimple *stmt) const final override;
 
   void on_condition (sm_context &sm_ctxt,
-		     const supernode *node,
-		     const gimple *stmt,
 		     const svalue *lhs,
 		     enum tree_code op,
 		     const svalue *rhs) const final override;
@@ -102,7 +99,6 @@ pattern_test_state_machine::pattern_test_state_machine (logger *logger)
 
 bool
 pattern_test_state_machine::on_stmt (sm_context &sm_ctxt ATTRIBUTE_UNUSED,
-				     const supernode *node ATTRIBUTE_UNUSED,
 				     const gimple *stmt ATTRIBUTE_UNUSED) const
 {
   return false;
@@ -116,22 +112,17 @@ pattern_test_state_machine::on_stmt (sm_context &sm_ctxt ATTRIBUTE_UNUSED,
 
 void
 pattern_test_state_machine::on_condition (sm_context &sm_ctxt,
-					  const supernode *node,
-					  const gimple *stmt,
 					  const svalue *lhs,
 					  enum tree_code op,
 					  const svalue *rhs) const
 {
-  if (stmt == nullptr)
-    return;
-
   tree rhs_cst = rhs->maybe_get_constant ();
   if (!rhs_cst)
     return;
 
   if (tree lhs_expr = sm_ctxt.get_diagnostic_tree (lhs))
     {
-      sm_ctxt.warn (node, stmt, lhs_expr,
+      sm_ctxt.warn (lhs_expr,
 		    std::make_unique<pattern_match> (lhs_expr, op, rhs_cst));
     }
 }
diff --git a/gcc/analyzer/sm-sensitive.cc b/gcc/analyzer/sm-sensitive.cc
index 4611b10e35a..08620481487 100644
--- a/gcc/analyzer/sm-sensitive.cc
+++ b/gcc/analyzer/sm-sensitive.cc
@@ -44,7 +44,6 @@ public:
   bool inherited_state_p () const final override { return true; }
 
   bool on_stmt (sm_context &sm_ctxt,
-		const supernode *node,
 		const gimple *stmt) const final override;
 
   bool can_purge_p (state_t s) const final override;
@@ -57,8 +56,6 @@ public:
 
 private:
   void warn_for_any_exposure (sm_context &sm_ctxt,
-			      const supernode *node,
-			      const gimple *stmt,
 			      tree arg) const;
 };
 
@@ -180,14 +177,12 @@ sensitive_state_machine::sensitive_state_machine (logger *logger)
 
 void
 sensitive_state_machine::warn_for_any_exposure (sm_context &sm_ctxt,
-						const supernode *node,
-						const gimple *stmt,
 						tree arg) const
 {
-  if (sm_ctxt.get_state (stmt, arg) == m_sensitive)
+  if (sm_ctxt.get_state (arg) == m_sensitive)
     {
       tree diag_arg = sm_ctxt.get_diagnostic_tree (arg);
-      sm_ctxt.warn (node, stmt, arg,
+      sm_ctxt.warn (arg,
 		    std::make_unique<exposure_through_output_file> (*this,
 								    diag_arg));
     }
@@ -198,7 +193,6 @@ sensitive_state_machine::warn_for_any_exposure (sm_context &sm_ctxt,
 
 bool
 sensitive_state_machine::on_stmt (sm_context &sm_ctxt,
-				  const supernode *node,
 				  const gimple *stmt) const
 {
   if (const gcall *call = dyn_cast <const gcall *> (stmt))
@@ -208,7 +202,7 @@ sensitive_state_machine::on_stmt (sm_context &sm_ctxt,
 	  {
 	    tree lhs = gimple_call_lhs (call);
 	    if (lhs)
-	      sm_ctxt.on_transition (node, stmt, lhs, m_start, m_sensitive);
+	      sm_ctxt.on_transition (lhs, m_start, m_sensitive);
 	    return true;
 	  }
 	else if (is_named_call_p (callee_fndecl, "fprintf")
@@ -218,14 +212,14 @@ sensitive_state_machine::on_stmt (sm_context &sm_ctxt,
 	    for (unsigned idx = 1; idx < gimple_call_num_args (call); idx++)
 	      {
 		tree arg = gimple_call_arg (call, idx);
-		warn_for_any_exposure (sm_ctxt, node, stmt, arg);
+		warn_for_any_exposure (sm_ctxt, arg);
 	      }
 	    return true;
 	  }
 	else if (is_named_call_p (callee_fndecl, "fwrite", *call, 4))
 	  {
 	    tree arg = gimple_call_arg (call, 0);
-	    warn_for_any_exposure (sm_ctxt, node, stmt, arg);
+	    warn_for_any_exposure (sm_ctxt, arg);
 	    return true;
 	  }
 	// TODO: ...etc.  This is just a proof-of-concept at this point.
